## hardinfo 2.2.7

=== CMakeLists.txt ===
#hardinfo2 supports CMake version 3.0.2->
if(${CMAKE_VERSION} VERSION_GREATER "3.30.99")
    cmake_minimum_required(VERSION 3.10.0)
    cmake_policy(VERSION 3.10.0)
    SET(CMAKE_EXECUTABLE_ENABLE_EXPORTS 1)
else()
    if(${CMAKE_VERSION} VERSION_GREATER "3.26.99")
        cmake_minimum_required(VERSION 3.5.0)
        cmake_policy(VERSION 3.5.0)
	SET(CMAKE_EXECUTABLE_ENABLE_EXPORTS 1)
    else()
        cmake_minimum_required(VERSION 3.0.2)
        cmake_policy(VERSION 3.0.2)
    endif()
endif()
project(hardinfo2)

set(HARDINFO2_VERSION "2.2.7")

option(HARDINFO2_SERVICE "Build with service support" 1)
option(HARDINFO2_GTK3 "Build for GTK3 (0/off for GTK2)" 1)
option(HARDINFO2_LIBSOUP3 "Build for libsoup-3.0 (0/off for libsoup-2.4)" 1)
option(HARDINFO2_QT5 "Build opengl benchmark for QT5 " 1)

SET(CMAKE_INSTALL_PREFIX "/usr")
SET(HARDINFO2_SYSTEMV 0)
SET(HARDINFO2_RUNIT 0)
file(READ "${CMAKE_CURRENT_SOURCE_DIR}/tools/org.hardinfo2.hardinfo2.metainfo.xml" METAINFO_CONTENT)

SET(CMAKE_MODULE_PATH  "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
include(GNUInstallDirs)

if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
	set(HARDINFO2_OS "linux")
else()
	message(FATAL_ERROR "Unsupported operating system: ${CMAKE_SYSTEM_NAME}")
endif()

if(${CMAKE_SYSTEM_PROCESSOR} MATCHES "i[3-6]86")
	set(HARDINFO2_ARCH "x86")
elseif(${CMAKE_SYSTEM_PROCESSOR} MATCHES "x86_64")
	set(HARDINFO2_ARCH "x86")
elseif(${CMAKE_SYSTEM_PROCESSOR} MATCHES "(ppc|ppc32|ppc64|ppc64le)")
	set(HARDINFO2_ARCH "ppc")
elseif(${CMAKE_SYSTEM_PROCESSOR} MATCHES "(mips|mips64el)")
	set(HARDINFO2_ARCH "mips")
elseif(${CMAKE_SYSTEM_PROCESSOR} MATCHES "parisc.*")
	set(HARDINFO2_ARCH "parisc")
elseif(${CMAKE_SYSTEM_PROCESSOR} MATCHES "sparc{32,64}")
	set(HARDINFO2_ARCH "sparc")
elseif(${CMAKE_SYSTEM_PROCESSOR} MATCHES "arm.*")
	set(HARDINFO2_ARCH "arm")
elseif(${CMAKE_SYSTEM_PROCESSOR} MATCHES "aarch64.*")
	set(HARDINFO2_ARCH "arm")
elseif(${CMAKE_SYSTEM_PROCESSOR} MATCHES "ia64")
	set(HARDINFO2_ARCH "ia64")
elseif(${CMAKE_SYSTEM_PROCESSOR} MATCHES "(loongarch64|loong64)")
	set(HARDINFO2_ARCH "loongarch64")
elseif(${CMAKE_SYSTEM_PROCESSOR} MATCHES "alpha")
	set(HARDINFO2_ARCH "alpha")
elseif(${CMAKE_SYSTEM_PROCESSOR} MATCHES "s390.*")
	set(HARDINFO2_ARCH "s390")
elseif(${CMAKE_SYSTEM_PROCESSOR} MATCHES "m68k")
	set(HARDINFO2_ARCH "m68k")
elseif(${CMAKE_SYSTEM_PROCESSOR} MATCHES "sh[3-5]")
	set(HARDINFO2_ARCH "sh")
elseif(${CMAKE_SYSTEM_PROCESSOR} MATCHES "(riscv|riscv32|riscv64)")
	set(HARDINFO2_ARCH "riscv")
elseif(${CMAKE_SYSTEM_PROCESSOR} MATCHES "e2k")
	set(HARDINFO2_ARCH "e2k")
else()
	message(FATAL_ERROR "Unsupported architecture: ${CMAKE_SYSTEM_PROCESSOR}")
endif()

add_definitions(-DLOCALEDIR="${CMAKE_INSTALL_FULL_LOCALEDIR}")
message(STATUS "LOCALEDIR = ${CMAKE_INSTALL_FULL_LOCALEDIR}")

message(STATUS "Building HardInfo2 for architecture: ${HARDINFO2_OS}-${HARDINFO2_ARCH}")

#add_definitions("-std=gnu89")
#add_definitions("-fanalyzer")
add_definitions("-Wextra")
add_definitions("-Wno-missing-field-initializers")
add_definitions("-Wformat")
add_definitions("-Wformat-security")

set(PACKAGE_LIBSOUP2_MINVERSION 2.42)
set(PACKAGE_LIBGLIB2_MINVERSION 2.24)
SET(RPM_REQ "sysbench, udisks2, glx-utils, lm_sensors, xdg-utils, iperf3, fwupd, xrandr, vulkan-tools, gawk")
SET(DEB_REQ "sysbench, udisks2, mesa-utils, lm-sensors, xdg-utils, iperf3, fwupd, x11-xserver-utils, vulkan-tools, gawk")

#########################CPack PACKAGING SETUP###############################
if(EXISTS "/etc/os-release")
  file(STRINGS /etc/os-release distro REGEX "^NAME=")
  file(STRINGS /etc/os-release disversion REGEX "^VERSION_ID=")
  file(STRINGS /etc/os-release disversioncode REGEX "^VERSION_CODENAME=")
else()
  set(distro "Linux")
  set(disversion "99")
  set(disversioncode "Linux")
endif()
set(RPM 0)
set(TGZ 0)
string(REGEX REPLACE "NAME=" "" distro "${distro}")
string(REGEX REPLACE "\"" "" distro "${distro}")
string(REGEX REPLACE "/" "" distro "${distro}")
string(REGEX REPLACE " " "" distro "${distro}")
string(REGEX REPLACE "VERSION_ID=" "" disversion "${disversion}")
string(COMPARE EQUAL "${disversion}" "" result)
if(result)
  #sid/rawhide with no version - use project name
  message("-- Found no distro version - Using codename")
  string(REGEX REPLACE "VERSION_CODENAME=" "" disversion "99_${disversioncode}")
endif()
string(REGEX REPLACE "\"" "" disversion "${disversion}")
string(REGEX REPLACE "/" "" disversion "${disversion}")
string(REGEX REPLACE " " "" disversion "${disversion}")
#RPM Distro's
if(${distro} MATCHES "Alma*" OR ${distro} MATCHES "Rocky*" OR ${distro} MATCHES "Fedora*" OR ${distro} MATCHES "RedHat*" OR ${distro} MATCHES "CentOS*" OR ${distro} MATCHES "Oracle*" OR ${distro} MATCHES "openSUSE*" OR ${distro} MATCHES "SUSE*" OR ${distro} MATCHES "PCLinuxOS*" OR ${distro} MATCHES "Ultramarine*" OR ${distro} MATCHES "Nobara*" OR ${distro} MATCHES "OpenMandriva*")
  set(RPM 1)
endif()
#Arch Distro's (tgz)
if(${distro} MATCHES "Arch*" OR ${distro} MATCHES "Endeavour*" OR ${distro} MATCHES "Garuda*" OR ${distro} MATCHES "Reborn*" OR ${distro} MATCHES "SystemRescue*" OR ${distro} MATCHES "Artix*" OR ${distro} MATCHES "Manjaro*")
  set(TGZ 1)
endif()
#Package architecture
if(${RPM})
  set(PACKAGE_DELIMITER "-")
  set(PACKAGE_ARCHITECTURE ".${CMAKE_SYSTEM_PROCESSOR}")
else()
  set(PACKAGE_DELIMITER "_")
  set(PACKAGE_ARCHITECTURE "_${CMAKE_SYSTEM_PROCESSOR}")
  if(${CMAKE_SYSTEM_PROCESSOR} MATCHES "x86_64")
    set(PACKAGE_ARCHITECTURE "_amd64")
  endif()
endif()
set(PACKAGE_DISTRO ${HARDINFO2_VERSION}-${distro}-${disversion}${CPACK_SYSTEM_NAME})
SET(CPACK_PACKAGE_VERSION ${HARDINFO2_VERSION})
#Put it together
string(REPLACE " " "${PACKAGE_DELIMITER}" CPACK_PACKAGE_FILE_NAME "hardinfo2${PACKAGE_DELIMITER}${PACKAGE_DISTRO}${PACKAGE_ARCHITECTURE}")
string(REPLACE " " "${PACKAGE_DELIMITER}" CPACK_SOURCE_PACKAGE_FILE_NAME "hardinfo2${PACKAGE_DELIMITER}${PACKAGE_DISTRO}${PACKAGE_ARCHITECTURE}")
message("-- Found Package Version ${CPACK_PACKAGE_VERSION}")
message("-- Found distro description ${distro}${disversion}")

#flavour output
set(HARDINFO2_OS ${distro})

#fedora ->35
if(${disversion} LESS 35.99)
  if(${distro} MATCHES "Fedora*")
    message("Fedora ->35 - LS24")
    set(HARDINFO2_LIBSOUP3 0)
  endif()
endif()

#centos/redhat/oracle ->9
if(${disversion} LESS 9.99)
  if(${distro} MATCHES "Red*" OR ${distro} MATCHES "CentOS*" OR ${distro} MATCHES "Oracle*" OR ${distro} MATCHES "Alma*" OR ${distro} MATCHES "Rocky*")
    message("Centos/Redhat/oracle/rocky/alma ->9 - LS24")
    set(HARDINFO2_LIBSOUP3 0)
  endif()
endif()

#centos/redhat/oracle/opensuse/suse ->8
if(${disversion} LESS 8.99)
  if(${distro} MATCHES "Red*" OR ${distro} MATCHES "CentOS*" OR ${distro} MATCHES "Oracle*" OR ${distro} MATCHES "openSUSE*" OR ${distro} MATCHES "Alma*" OR ${distro} MATCHES "Rocky*")
    message("Centos/Redhat/oracle/opensuse/suse/rocky/alma ->8 - Old Appstream metainfo")
    string(REPLACE "<url type=\"contact\">https://github.com/hardinfo2/hardinfo2/discussions</url>" "" METAINFO_CONTENT "${METAINFO_CONTENT}" )
  endif()
endif()

#centos/redhat/oracle 10
if((${disversion} GREATER_EQUAL 10) AND (${disversion} LESS 10.99))
  if(${distro} MATCHES "Red*" OR ${distro} MATCHES "CentOS*" OR ${distro} MATCHES "Oracle*" OR ${distro} MATCHES "Alma*" OR ${distro} MATCHES "Rocky*")
    message("Centos/Redhat/oracle/rocky/alma 10 - Missing xrandr+sysbench!!!")
    SET(RPM_REQ "udisks2, glx-utils, lm_sensors, xdg-utils, iperf3, fwupd, vulkan-tools, gawk") #miss sysbench, xrandr
  endif()
endif()

#centos/redhat/oracle/opensuse/suse 7
if(${disversion} LESS 7.99)
  if((${distro} MATCHES "Red*" OR ${distro} MATCHES "CentOS*" OR ${distro} MATCHES "Oracle*" OR ${distro} MATCHES "openSUSE*" OR ${distro} MATCHES "SUSE*"))
      SET(RPM_REQ "sysbench, udisks2, glx-utils, lm_sensors, xdg-utils, iperf3, fwupd, xrandr, gawk") #miss vulkan-tools
  endif()
endif()

#centos/redhat/oracle/opensuse/suse 6
if(${disversion} LESS 6.99)
  if((${distro} MATCHES "Red*" OR ${distro} MATCHES "CentOS*" OR ${distro} MATCHES "Oracle*" OR ${distro} MATCHES "openSUSE*" OR ${distro} MATCHES "SUSE*"))
    message("RPM EL6 - Too old to have run directory - creating at install")
    #create run directory owned by root
    install(DIRECTORY DESTINATION /run)
    message("RPM EL6 - GTK2 - deprecated - support will end at any time")
    set(HARDINFO2_GTK3 0)
    message("RPM EL6 - LS24 - deprecated version 2.34.3 - but ok")
    set(PACKAGE_LIBSOUP2_MINVERSION 2.34.3)
    set(HARDINFO2_SYSTEMV 1)
    message("RPM EL6 - no QT5 - Disabling opengl benchmarks")
    set(HARDINFO2_QT5 0)
    SET(RPM_REQ "sysbench, glx-utils, lm_sensors, xdg-utils, xrandr, gawk") #miss vulkan-tools, udisks2, fwupd, iperf3
  endif()
endif()

#opensuse tumbeweed
if(${disversion} GREATER 20000101)
  if(${distro} MATCHES "openSUSE*")
    SET(RPM_REQ "sysbench, udisks2, xdg-utils, fwupd, xrandr,vulkan-tools,  Mesa-demo-x, iperf, sensors, gawk")
  endif()
endif()


#Fedora 23
if(${distro}${disversion} MATCHES "Fedora23")
    message("FC23 - no QT5 - Disabling opengl benchmarks")
    set(HARDINFO2_QT5 0)
    SET(RPM_REQ "sysbench, udisks2, glx-utils, lm_sensors, xdg-utils, iperf3, fwupd, xrandr, gawk") #miss vulkan-tools
    message("Fedora 23 - Too Old for Appstream metainfo")
    string(REPLACE "<component type=\"desktop-application\">" "<component>" METAINFO_CONTENT "${METAINFO_CONTENT}" )
    string(REPLACE "<url type=\"contact\">https://github.com/hardinfo2/hardinfo2/discussions</url>" "" METAINFO_CONTENT "${METAINFO_CONTENT}" )
    string(REPLACE "<url type=\"contact\">https://github.com/hardinfo2/hardinfo2/discussions</url>" "" METAINFO_CONTENT "${METAINFO_CONTENT}" )
    string(REPLACE "<url type=\"translate\">https://github.com/hardinfo2/hardinfo2/tree/master/po</url>" "" METAINFO_CONTENT "${METAINFO_CONTENT}" )
endif()

#debian 7
if(${distro}${disversion} MATCHES "DebianGNULinux7")
    message("DEB 7 - GTK2 to avoid c11 for ubergraph - deprecated - support will end at any time")
    message("DEB 7 - LS24 - deprecated version 2.34.3 - but ok")
    message("DEB 7 - no QT5 - Disabling opengl benchmarks")
    set(HARDINFO2_GTK3 0)
    set(PACKAGE_LIBSOUP2_MINVERSION 2.34.3)
    set(HARDINFO2_SYSTEMV 1)
    set(HARDINFO2_QT5 0)
    SET(DEB_REQ "sysbench, mesa-utils, lm-sensors, xdg-utils, x11-xserver-utils, libsigsegv2, gawk") #miss vulkan-tools,fwupd, udisks2, iperf3 +libsigsegv2 for gawk
endif()

#debian 8
if(${distro}${disversion} MATCHES "DebianGNULinux8")
    message("DEB 8 - GTK3 version 3.14.5 is low - Themes disabled")
    message("DEB 8 - no QT5 - Disabling opengl benchmarks")
    set(HARDINFO2_QT5 0)
    SET(DEB_REQ "sysbench, udisks2, mesa-utils, lm-sensors, xdg-utils, iperf3, x11-xserver-utils, libsigsegv2, gawk") #miss vulkan-tools,fwupd +libsigsegv2 for gawk
endif()

#debian 9
if(${distro}${disversion} MATCHES "DebianGNULinux99")
else()
    if(${distro}${disversion} MATCHES "DebianGNULinux9")
        message("DEB 9 - QT5 too low - Disabling opengl benchmarks")
        set(HARDINFO2_QT5 0)
	SET(DEB_REQ "sysbench, udisks2, mesa-utils, lm-sensors, xdg-utils, iperf3, fwupd, x11-xserver-utils, gawk") #miss vulkan-tools
    endif()
endif()

#debian 10
if(${distro}${disversion} MATCHES "DebianGNULinux10")
  SET(DEB_REQ "udisks2, mesa-utils, lm-sensors, xdg-utils, iperf3, fwupd, x11-xserver-utils, vulkan-tools, gawk") #miss sysbench
endif()

#debian ->11
if(${disversion} LESS 11.99)
  if(${distro} MATCHES "DebianGNULinux")
    message("DEB ->11 - LS24")
    set(HARDINFO2_LIBSOUP3 0)
  endif()
  if(${distro} MATCHES "RaspbianGNULinux")
    message("DEB ->11 - LS24")
    set(HARDINFO2_LIBSOUP3 0)
  endif()
endif()

#pureos ->10 (debian 11 or less)
if(${disversion} LESS 10.99)
  if(${distro} MATCHES "PureOS")
    message("PureOS ->10 - LS24")
    set(HARDINFO2_LIBSOUP3 0)
  endif()
endif()

#ubuntu 16
if(${distro}${disversion} MATCHES "Ubuntu16")
    message("Ubuntu 16 - no QT5 - Disabling opengl benchmarks")
    set(HARDINFO2_QT5 0)

=== deps/qgears2/CMakeLists.txt ===
message(STATUS "qgears2 module being added...")

find_package(Qt5 REQUIRED Core Gui Widgets OpenGL)
include(FindPkgConfig)

execute_process(COMMAND moc -DQT_NO_DEBUG -DQT_OPENGL_LIB -DQT_WIDGETS_LIB -DQT_GUI_LIB -DQT_CORE_LIB ${CMAKE_CURRENT_SOURCE_DIR}/qgears.h -o ${CMAKE_CURRENT_BINARY_DIR}/moc_qgears.cpp)
execute_process(COMMAND moc -DQT_NO_DEBUG -DQT_OPENGL_LIB -DQT_WIDGETS_LIB -DQT_GUI_LIB -DQT_CORE_LIB ${CMAKE_CURRENT_SOURCE_DIR}/qglgears.h -o ${CMAKE_CURRENT_BINARY_DIR}/moc_qglgears.cpp)
execute_process(COMMAND /usr/bin/moc -DQT_NO_DEBUG -DQT_OPENGL_LIB -DQT_WIDGETS_LIB -DQT_GUI_LIB -DQT_CORE_LIB ${CMAKE_CURRENT_SOURCE_DIR}/qgears.h -o ${CMAKE_CURRENT_BINARY_DIR}/moc_qgears.cpp)
execute_process(COMMAND /usr/bin/moc -DQT_NO_DEBUG -DQT_OPENGL_LIB -DQT_WIDGETS_LIB -DQT_GUI_LIB -DQT_CORE_LIB ${CMAKE_CURRENT_SOURCE_DIR}/qglgears.h -o ${CMAKE_CURRENT_BINARY_DIR}/moc_qglgears.cpp)
execute_process(COMMAND /usr/lib/qt5/bin/moc -DQT_NO_DEBUG -DQT_OPENGL_LIB -DQT_WIDGETS_LIB -DQT_GUI_LIB -DQT_CORE_LIB ${CMAKE_CURRENT_SOURCE_DIR}/qgears.h -o ${CMAKE_CURRENT_BINARY_DIR}/moc_qgears.cpp)
execute_process(COMMAND /usr/lib/qt5/bin/moc -DQT_NO_DEBUG -DQT_OPENGL_LIB -DQT_WIDGETS_LIB -DQT_GUI_LIB -DQT_CORE_LIB ${CMAKE_CURRENT_SOURCE_DIR}/qglgears.h -o ${CMAKE_CURRENT_BINARY_DIR}/moc_qglgears.cpp)
execute_process(COMMAND /usr/lib64/qt5/bin/moc -DQT_NO_DEBUG -DQT_OPENGL_LIB -DQT_WIDGETS_LIB -DQT_GUI_LIB -DQT_CORE_LIB ${CMAKE_CURRENT_SOURCE_DIR}/qgears.h -o ${CMAKE_CURRENT_BINARY_DIR}/moc_qgears.cpp)
execute_process(COMMAND /usr/lib64/qt5/bin/moc -DQT_NO_DEBUG -DQT_OPENGL_LIB -DQT_WIDGETS_LIB -DQT_GUI_LIB -DQT_CORE_LIB ${CMAKE_CURRENT_SOURCE_DIR}/qglgears.h -o ${CMAKE_CURRENT_BINARY_DIR}/moc_qglgears.cpp)
execute_process(COMMAND /usr/lib/i386-linux-gnu/qt5/bin/moc -DQT_NO_DEBUG -DQT_OPENGL_LIB -DQT_WIDGETS_LIB -DQT_GUI_LIB -DQT_CORE_LIB ${CMAKE_CURRENT_SOURCE_DIR}/qgears.h -o ${CMAKE_CURRENT_BINARY_DIR}/moc_qgears.cpp)
execute_process(COMMAND /usr/lib/i386-linux-gnu/qt5/bin/moc -DQT_NO_DEBUG -DQT_OPENGL_LIB -DQT_WIDGETS_LIB -DQT_GUI_LIB -DQT_CORE_LIB ${CMAKE_CURRENT_SOURCE_DIR}/qglgears.h -o ${CMAKE_CURRENT_BINARY_DIR}/moc_qglgears.cpp)

include_directories(
  .
  Qt5::OpenGL
  Qt5::Widgets
  Qt5::Gui
  Qt5::Core
)

add_executable(qgears2
  main.cpp
  qgears.cpp
  commonrenderer.cpp
  qglgears.cpp
  fdclock.cpp
  ${CMAKE_CURRENT_BINARY_DIR}/moc_qgears.cpp
  ${CMAKE_CURRENT_BINARY_DIR}/moc_qglgears.cpp
)

set_target_properties(qgears2 PROPERTIES COMPILE_FLAGS "-pipe -O2 -Wall -Wextra -D_REENTRANT -fPIC")

target_link_libraries(qgears2
  GL
  pthread
  Qt5::OpenGL
  Qt5::Widgets
  Qt5::Gui
  Qt5::Core
)

install(FILES ${CMAKE_BINARY_DIR}/deps/qgears2/qgears2 DESTINATION ${CMAKE_INSTALL_LIBDIR}/hardinfo2/modules
	PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
)
      
message(STATUS "qgears2 module added - DONE")

=== debian/changelog ===
hardinfo (2.2.7-1) unstable; urgency=medium

  * New upstream release.
  * debian/control: Remove recommends of lsscsi.
  * debian/control: Depends on gawk.

 -- Boyuan Yang <byang@debian.org>  Tue, 04 Feb 2025 09:02:02 -0500

=== debian/control ===
Source: hardinfo
Section: x11
Priority: optional
Maintainer: Boyuan Yang <byang@debian.org>
Uploaders:
 Simon Quigley <tsimonq2@debian.org>,
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 gettext,
 libglib2.0-dev,
 libgtk-3-dev,
 libjson-glib-dev,
 libqt5opengl5-dev,
 libsoup-3.0-dev,
 qtbase5-dev,
 qtbase5-dev-tools,
 zlib1g-dev,
Standards-Version: 4.7.0
Homepage: https://github.com/hardinfo2/hardinfo2
Vcs-Git: https://salsa.debian.org/debian/hardinfo.git
Vcs-Browser: https://salsa.debian.org/debian/hardinfo
Description: System Information and Benchmark for Linux Systems
 Hardinfo offers System Information and Benchmark for Linux Systems.
 It is able to obtain information from both hardware and basic software.
 It can benchmark your system and compare to other machines online.

Package: hardinfo
Section: oldlibs
Architecture: all
Depends:
 hardinfo2,
 ${misc:Depends},
Description: transitional package
 This is a transitional package. It can safely be removed.

Package: hardinfo2
Architecture: linux-any
Depends:
 gawk,
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 dmidecode,
 fwupd,
 iperf3,
 lm-sensors,
 mesa-utils,
 sysbench,
 udisks2,
 vulkan-tools,
 x11-xserver-utils,
 xdg-utils,
Suggests:
 pciutils,
Replaces:
 hardinfo (<< ${binary:Version}~),
Breaks:
 hardinfo (<< ${binary:Version}~),
Provides:
 hardinfo,
Description: ${source:Synopsis}
 ${source:Extended-Description}

## hardinfo 2.2.10

=== CMakeLists.txt ===
--- 
+++ 
@@ -15,8 +15,12 @@
 endif()
 project(hardinfo2)
 
-set(HARDINFO2_VERSION "2.2.7")
-
+#Release settings
+set(HARDINFO2_VERSION "2.2.10")
+set(HARDINFO2_RELEASE_DATE "2025-03-29")
+set(HARDINFO2_RELEASE_NOTE_HTML "<p>Release</p><p>\nImprovements\nLots of minor fixes/maintenance/updates/cleanup\nFor details see homepage news.</p>")
+
+#Build settings
 option(HARDINFO2_SERVICE "Build with service support" 1)
 option(HARDINFO2_GTK3 "Build for GTK3 (0/off for GTK2)" 1)
 option(HARDINFO2_LIBSOUP3 "Build for libsoup-3.0 (0/off for libsoup-2.4)" 1)
@@ -25,7 +29,11 @@
 SET(CMAKE_INSTALL_PREFIX "/usr")
 SET(HARDINFO2_SYSTEMV 0)
 SET(HARDINFO2_RUNIT 0)
+string(SUBSTRING ${HARDINFO2_RELEASE_DATE} 0 4 HARDINFO2_RELEASE_YEAR)
 file(READ "${CMAKE_CURRENT_SOURCE_DIR}/tools/org.hardinfo2.hardinfo2.metainfo.xml" METAINFO_CONTENT)
+string(REPLACE "VERSION" "${HARDINFO2_VERSION}" METAINFO_CONTENT "${METAINFO_CONTENT}" )
+string(REPLACE "RELEASE_DATE" "${HARDINFO2_RELEASE_DATE}" METAINFO_CONTENT "${METAINFO_CONTENT}" )
+string(REPLACE "DESCRIPTION" "${HARDINFO2_RELEASE_NOTE_HTML}" METAINFO_CONTENT "${METAINFO_CONTENT}" )
 
 SET(CMAKE_MODULE_PATH  "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
 include(GNUInstallDirs)
@@ -46,7 +54,7 @@
 	set(HARDINFO2_ARCH "mips")
 elseif(${CMAKE_SYSTEM_PROCESSOR} MATCHES "parisc.*")
 	set(HARDINFO2_ARCH "parisc")
-elseif(${CMAKE_SYSTEM_PROCESSOR} MATCHES "sparc{32,64}")
+elseif(${CMAKE_SYSTEM_PROCESSOR} MATCHES "sparc32|sparc64")
 	set(HARDINFO2_ARCH "sparc")
 elseif(${CMAKE_SYSTEM_PROCESSOR} MATCHES "arm.*")
 	set(HARDINFO2_ARCH "arm")
@@ -86,8 +94,8 @@
 
 set(PACKAGE_LIBSOUP2_MINVERSION 2.42)
 set(PACKAGE_LIBGLIB2_MINVERSION 2.24)
-SET(RPM_REQ "sysbench, udisks2, glx-utils, lm_sensors, xdg-utils, iperf3, fwupd, xrandr, vulkan-tools, gawk")
-SET(DEB_REQ "sysbench, udisks2, mesa-utils, lm-sensors, xdg-utils, iperf3, fwupd, x11-xserver-utils, vulkan-tools, gawk")
+SET(RPM_REQ "dmidecode, sysbench, udisks2, glx-utils, lm_sensors, xdg-utils, iperf3, fwupd, xrandr, vulkan-tools, gawk")
+SET(DEB_REQ "dmidecode, sysbench, udisks2, mesa-utils, lm-sensors, xdg-utils, iperf3, fwupd, x11-xserver-utils, vulkan-tools, gawk")
 
 #########################CPack PACKAGING SETUP###############################
 if(EXISTS "/etc/os-release")
@@ -173,14 +181,14 @@
 if((${disversion} GREATER_EQUAL 10) AND (${disversion} LESS 10.99))
   if(${distro} MATCHES "Red*" OR ${distro} MATCHES "CentOS*" OR ${distro} MATCHES "Oracle*" OR ${distro} MATCHES "Alma*" OR ${distro} MATCHES "Rocky*")
     message("Centos/Redhat/oracle/rocky/alma 10 - Missing xrandr+sysbench!!!")
-    SET(RPM_REQ "udisks2, glx-utils, lm_sensors, xdg-utils, iperf3, fwupd, vulkan-tools, gawk") #miss sysbench, xrandr
+    SET(RPM_REQ "dmidecode, udisks2, glx-utils, lm_sensors, xdg-utils, iperf3, fwupd, vulkan-tools, gawk") #miss sysbench, xrandr
   endif()
 endif()
 
 #centos/redhat/oracle/opensuse/suse 7
 if(${disversion} LESS 7.99)
   if((${distro} MATCHES "Red*" OR ${distro} MATCHES "CentOS*" OR ${distro} MATCHES "Oracle*" OR ${distro} MATCHES "openSUSE*" OR ${distro} MATCHES "SUSE*"))
-      SET(RPM_REQ "sysbench, udisks2, glx-utils, lm_sensors, xdg-utils, iperf3, fwupd, xrandr, gawk") #miss vulkan-tools
+      SET(RPM_REQ "dmidecode, sysbench, udisks2, glx-utils, lm_sensors, xdg-utils, iperf3, fwupd, xrandr, gawk") #miss vulkan-tools
   endif()
 endif()
 
@@ -197,14 +205,14 @@
     set(HARDINFO2_SYSTEMV 1)
     message("RPM EL6 - no QT5 - Disabling opengl benchmarks")
     set(HARDINFO2_QT5 0)
-    SET(RPM_REQ "sysbench, glx-utils, lm_sensors, xdg-utils, xrandr, gawk") #miss vulkan-tools, udisks2, fwupd, iperf3
+    SET(RPM_REQ "dmidecode, sysbench, glx-utils, lm_sensors, xdg-utils, xrandr, gawk") #miss vulkan-tools, udisks2, fwupd, iperf3
   endif()
 endif()
 
 #opensuse tumbeweed
 if(${disversion} GREATER 20000101)
   if(${distro} MATCHES "openSUSE*")
-    SET(RPM_REQ "sysbench, udisks2, xdg-utils, fwupd, xrandr,vulkan-tools,  Mesa-demo-x, iperf, sensors, gawk")
+    SET(RPM_REQ "dmidecode, sysbench, udisks2, xdg-utils, fwupd, xrandr,vulkan-tools,  Mesa-demo-x, iperf, sensors, gawk")
   endif()
 endif()
 
@@ -213,7 +221,7 @@
 if(${distro}${disversion} MATCHES "Fedora23")
     message("FC23 - no QT5 - Disabling opengl benchmarks")
     set(HARDINFO2_QT5 0)
-    SET(RPM_REQ "sysbench, udisks2, glx-utils, lm_sensors, xdg-utils, iperf3, fwupd, xrandr, gawk") #miss vulkan-tools
+    SET(RPM_REQ "dmidecode, sysbench, udisks2, glx-utils, lm_sensors, xdg-utils, iperf3, fwupd, xrandr, gawk") #miss vulkan-tools
     message("Fedora 23 - Too Old for Appstream metainfo")
     string(REPLACE "<component type=\"desktop-application\">" "<component>" METAINFO_CONTENT "${METAINFO_CONTENT}" )
     string(REPLACE "<url type=\"contact\">https://github.com/hardinfo2/hardinfo2/discussions</url>" "" METAINFO_CONTENT "${METAINFO_CONTENT}" )
@@ -230,7 +238,7 @@
     set(PACKAGE_LIBSOUP2_MINVERSION 2.34.3)
     set(HARDINFO2_SYSTEMV 1)
     set(HARDINFO2_QT5 0)
-    SET(DEB_REQ "sysbench, mesa-utils, lm-sensors, xdg-utils, x11-xserver-utils, libsigsegv2, gawk") #miss vulkan-tools,fwupd, udisks2, iperf3 +libsigsegv2 for gawk
+    SET(DEB_REQ "dmidecode, sysbench, mesa-utils, lm-sensors, xdg-utils, x11-xserver-utils, libsigsegv2, gawk") #miss vulkan-tools,fwupd, udisks2, iperf3 +libsigsegv2 for gawk
 endif()
 
 #debian 8
@@ -238,7 +246,7 @@
     message("DEB 8 - GTK3 version 3.14.5 is low - Themes disabled")
     message("DEB 8 - no QT5 - Disabling opengl benchmarks")
     set(HARDINFO2_QT5 0)
-    SET(DEB_REQ "sysbench, udisks2, mesa-utils, lm-sensors, xdg-utils, iperf3, x11-xserver-utils, libsigsegv2, gawk") #miss vulkan-tools,fwupd +libsigsegv2 for gawk
+    SET(DEB_REQ "dmidecode, sysbench, udisks2, mesa-utils, lm-sensors, xdg-utils, iperf3, x11-xserver-utils, libsigsegv2, gawk") #miss vulkan-tools,fwupd +libsigsegv2 for gawk
 endif()
 
 #debian 9
@@ -247,36 +255,9 @@
     if(${distro}${disversion} MATCHES "DebianGNULinux9")
         message("DEB 9 - QT5 too low - Disabling opengl benchmarks")
         set(HARDINFO2_QT5 0)
-	SET(DEB_REQ "sysbench, udisks2, mesa-utils, lm-sensors, xdg-utils, iperf3, fwupd, x11-xserver-utils, gawk") #miss vulkan-tools
+	SET(DEB_REQ "dmidecode, sysbench, udisks2, mesa-utils, lm-sensors, xdg-utils, iperf3, fwupd, x11-xserver-utils, gawk") #miss vulkan-tools
     endif()
 endif()
 
 #debian 10
 if(${distro}${disversion} MATCHES "DebianGNULinux10")
-  SET(DEB_REQ "udisks2, mesa-utils, lm-sensors, xdg-utils, iperf3, fwupd, x11-xserver-utils, vulkan-tools, gawk") #miss sysbench
-endif()
-
-#debian ->11
-if(${disversion} LESS 11.99)
-  if(${distro} MATCHES "DebianGNULinux")
-    message("DEB ->11 - LS24")
-    set(HARDINFO2_LIBSOUP3 0)
-  endif()
-  if(${distro} MATCHES "RaspbianGNULinux")
-    message("DEB ->11 - LS24")
-    set(HARDINFO2_LIBSOUP3 0)
-  endif()
-endif()
-
-#pureos ->10 (debian 11 or less)
-if(${disversion} LESS 10.99)
-  if(${distro} MATCHES "PureOS")
-    message("PureOS ->10 - LS24")
-    set(HARDINFO2_LIBSOUP3 0)
-  endif()
-endif()
-
-#ubuntu 16
-if(${distro}${disversion} MATCHES "Ubuntu16")
-    message("Ubuntu 16 - no QT5 - Disabling opengl benchmarks")
-    set(HARDINFO2_QT5 0)

=== debian/changelog ===
hardinfo (2.2.10-1) unstable; urgency=medium

  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Sat, 29 Mar 2025 11:25:19 -0400

=== debian/control ===
--- 
+++ 
@@ -16,7 +16,7 @@
  qtbase5-dev,
  qtbase5-dev-tools,
  zlib1g-dev,
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Homepage: https://github.com/hardinfo2/hardinfo2
 Vcs-Git: https://salsa.debian.org/debian/hardinfo.git
 Vcs-Browser: https://salsa.debian.org/debian/hardinfo

=== debian/rules ===
#!/usr/bin/make -f

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --buildsystem=cmake

## hardinfo 2.2.13

=== CMakeLists.txt ===
--- 
+++ 
@@ -16,15 +16,20 @@
 project(hardinfo2)
 
 #Release settings
-set(HARDINFO2_VERSION "2.2.10")
-set(HARDINFO2_RELEASE_DATE "2025-03-29")
-set(HARDINFO2_RELEASE_NOTE_HTML "<p>Release</p><p>\nImprovements\nLots of minor fixes/maintenance/updates/cleanup\nFor details see homepage news.</p>")
+set(HARDINFO2_VERSION "2.2.13")
+set(HARDINFO2_RELEASE_DATE "2025-05-08")
+set(HARDINFO2_RELEASE_NOTE_HTML "<p>Release</p><p>\nNew Vulkan Benchmark\nImproved CLI usage\nBenchmark Filtering features\nLots of minor fixes/maintenance/updates/cleanup\nFor details see homepage news.</p>")
 
 #Build settings
 option(HARDINFO2_SERVICE "Build with service support" 1)
 option(HARDINFO2_GTK3 "Build for GTK3 (0/off for GTK2)" 1)
 option(HARDINFO2_LIBSOUP3 "Build for libsoup-3.0 (0/off for libsoup-2.4)" 1)
-option(HARDINFO2_QT5 "Build opengl benchmark for QT5 " 1)
+option(HARDINFO2_QT5 "Build opengl benchmark for QT5" 1)
+option(HARDINFO2_QT5_MOCQT5 "Build QT5 with moc-qt5" 0)
+option(HARDINFO2_VK "Build vulkan benchmark" 1)
+option(HARDINFO2_VK_WAYLAND "Build Vulkan with wayland support" 1)
+option(HARDINFO2_VK_X11 "Build Vulkan with X11 support" 1)
+option(HARDINFO2_NOSSL "Build for very old distro with no https" 0)
 
 SET(CMAKE_INSTALL_PREFIX "/usr")
 SET(HARDINFO2_SYSTEMV 0)
@@ -125,6 +130,8 @@
 string(REGEX REPLACE " " "" disversion "${disversion}")
 #RPM Distro's
 if(${distro} MATCHES "Alma*" OR ${distro} MATCHES "Rocky*" OR ${distro} MATCHES "Fedora*" OR ${distro} MATCHES "RedHat*" OR ${distro} MATCHES "CentOS*" OR ${distro} MATCHES "Oracle*" OR ${distro} MATCHES "openSUSE*" OR ${distro} MATCHES "SUSE*" OR ${distro} MATCHES "PCLinuxOS*" OR ${distro} MATCHES "Ultramarine*" OR ${distro} MATCHES "Nobara*" OR ${distro} MATCHES "OpenMandriva*")
+  #ALT Linux is RPM but too old rpmbuild - use alien until fixed
+  # OR ${distro} MATCHES "ALT*" OR ${distro} MATCHES "SimplyLinux"
   set(RPM 1)
 endif()
 #Arch Distro's (tgz)
@@ -172,16 +179,23 @@
 #centos/redhat/oracle/opensuse/suse ->8
 if(${disversion} LESS 8.99)
   if(${distro} MATCHES "Red*" OR ${distro} MATCHES "CentOS*" OR ${distro} MATCHES "Oracle*" OR ${distro} MATCHES "openSUSE*" OR ${distro} MATCHES "Alma*" OR ${distro} MATCHES "Rocky*")
-    message("Centos/Redhat/oracle/opensuse/suse/rocky/alma ->8 - Old Appstream metainfo")
+    message("Centos/Redhat/oracle/opensuse/suse/rocky/alma ->8 - Old Appstream metainfo VK_WAYLAND=0")
+    SET(HARDINFO2_VK_WAYLAND 0)
     string(REPLACE "<url type=\"contact\">https://github.com/hardinfo2/hardinfo2/discussions</url>" "" METAINFO_CONTENT "${METAINFO_CONTENT}" )
   endif()
 endif()
 
 #centos/redhat/oracle 10
 if((${disversion} GREATER_EQUAL 10) AND (${disversion} LESS 10.99))
-  if(${distro} MATCHES "Red*" OR ${distro} MATCHES "CentOS*" OR ${distro} MATCHES "Oracle*" OR ${distro} MATCHES "Alma*" OR ${distro} MATCHES "Rocky*")
-    message("Centos/Redhat/oracle/rocky/alma 10 - Missing xrandr+sysbench!!!")
-    SET(RPM_REQ "dmidecode, udisks2, glx-utils, lm_sensors, xdg-utils, iperf3, fwupd, vulkan-tools, gawk") #miss sysbench, xrandr
+  if(${distro} MATCHES "CentOS*" OR ${distro} MATCHES "Oracle*" OR ${distro} MATCHES "Alma*" OR ${distro} MATCHES "Rocky*")
+    message("Centos/Redhat/oracle/rocky/alma 10 - Missing xrandr vue to wayland standard")
+    SET(RPM_REQ "dmidecode, sysbench, udisks2, glx-utils, lm_sensors, xdg-utils, iperf3, fwupd, vulkan-tools, gawk") #miss xrandr
+  endif()
+  #below to be removed when Redhat switches to epel10_1
+  if(${distro} MATCHES "Red*")
+    message("Centos/Redhat/oracle/rocky/alma 10 - Missing xrandr vue to wayland standard")
+    message("Redhat - Missing sysbench - old epel10_0 instead of epel10_1")
+    SET(RPM_REQ "dmidecode, udisks2, glx-utils, lm_sensors, xdg-utils, iperf3, fwupd, vulkan-tools, gawk") #miss xrandr sysbench
   endif()
 endif()
 
@@ -189,6 +203,7 @@
 if(${disversion} LESS 7.99)
   if((${distro} MATCHES "Red*" OR ${distro} MATCHES "CentOS*" OR ${distro} MATCHES "Oracle*" OR ${distro} MATCHES "openSUSE*" OR ${distro} MATCHES "SUSE*"))
       SET(RPM_REQ "dmidecode, sysbench, udisks2, glx-utils, lm_sensors, xdg-utils, iperf3, fwupd, xrandr, gawk") #miss vulkan-tools
+      set(HARDINFO2_VK 0)
   endif()
 endif()
 
@@ -203,24 +218,36 @@
     message("RPM EL6 - LS24 - deprecated version 2.34.3 - but ok")
     set(PACKAGE_LIBSOUP2_MINVERSION 2.34.3)
     set(HARDINFO2_SYSTEMV 1)
-    message("RPM EL6 - no QT5 - Disabling opengl benchmarks")
+    message("RPM EL6 - no QT5+VK - Disabling benchmarks")
     set(HARDINFO2_QT5 0)
+    set(HARDINFO2_VK 0)
+    message("RPM EL6 - NOSSL too old for https")
+    set(HARDINFO2_NOSSL 1)
     SET(RPM_REQ "dmidecode, sysbench, glx-utils, lm_sensors, xdg-utils, xrandr, gawk") #miss vulkan-tools, udisks2, fwupd, iperf3
   endif()
 endif()
 
-#opensuse tumbeweed
-if(${disversion} GREATER 20000101)
-  if(${distro} MATCHES "openSUSE*")
-    SET(RPM_REQ "dmidecode, sysbench, udisks2, xdg-utils, fwupd, xrandr,vulkan-tools,  Mesa-demo-x, iperf, sensors, gawk")
+#opensuse
+if(${distro} MATCHES "openSUSE*")
+  SET(RPM_REQ "dmidecode, sysbench, udisks2, xdg-utils, fwupd, xrandr,vulkan-tools,  Mesa-demo-x, iperf, sensors, gawk")
+  #opensuse tumbeweed
+  if(${disversion} GREATER 20000101)
+  else()
+    #opensuse leap 16
+    if(${disversion} GREATER 15.99)
+       SET(RPM_REQ "dmidecode, sysbench, udisks2, xdg-utils, xrandr,vulkan-tools,  Mesa-demo-x, iperf, sensors, gawk") #Some error for fwupd vs KDE6 dependencies
+    endif()
   endif()
 endif()
 
 
 #Fedora 23
 if(${distro}${disversion} MATCHES "Fedora23")
-    message("FC23 - no QT5 - Disabling opengl benchmarks")
+    message("FC23 - no QT5+VK - Disabling benchmarks")
     set(HARDINFO2_QT5 0)
+    set(HARDINFO2_VK 0)
+    message("Fedora 23 - Too Old for HTTPS")
+    set(HARDINFO2_NOSSL 1)
     SET(RPM_REQ "dmidecode, sysbench, udisks2, glx-utils, lm_sensors, xdg-utils, iperf3, fwupd, xrandr, gawk") #miss vulkan-tools
     message("Fedora 23 - Too Old for Appstream metainfo")
     string(REPLACE "<component type=\"desktop-application\">" "<component>" METAINFO_CONTENT "${METAINFO_CONTENT}" )
@@ -231,33 +258,3 @@
 
 #debian 7
 if(${distro}${disversion} MATCHES "DebianGNULinux7")
-    message("DEB 7 - GTK2 to avoid c11 for ubergraph - deprecated - support will end at any time")
-    message("DEB 7 - LS24 - deprecated version 2.34.3 - but ok")
-    message("DEB 7 - no QT5 - Disabling opengl benchmarks")
-    set(HARDINFO2_GTK3 0)
-    set(PACKAGE_LIBSOUP2_MINVERSION 2.34.3)
-    set(HARDINFO2_SYSTEMV 1)
-    set(HARDINFO2_QT5 0)
-    SET(DEB_REQ "dmidecode, sysbench, mesa-utils, lm-sensors, xdg-utils, x11-xserver-utils, libsigsegv2, gawk") #miss vulkan-tools,fwupd, udisks2, iperf3 +libsigsegv2 for gawk
-endif()
-
-#debian 8
-if(${distro}${disversion} MATCHES "DebianGNULinux8")
-    message("DEB 8 - GTK3 version 3.14.5 is low - Themes disabled")
-    message("DEB 8 - no QT5 - Disabling opengl benchmarks")
-    set(HARDINFO2_QT5 0)
-    SET(DEB_REQ "dmidecode, sysbench, udisks2, mesa-utils, lm-sensors, xdg-utils, iperf3, x11-xserver-utils, libsigsegv2, gawk") #miss vulkan-tools,fwupd +libsigsegv2 for gawk
-endif()
-
-#debian 9
-if(${distro}${disversion} MATCHES "DebianGNULinux99")
-else()
-    if(${distro}${disversion} MATCHES "DebianGNULinux9")
-        message("DEB 9 - QT5 too low - Disabling opengl benchmarks")
-        set(HARDINFO2_QT5 0)
-	SET(DEB_REQ "dmidecode, sysbench, udisks2, mesa-utils, lm-sensors, xdg-utils, iperf3, fwupd, x11-xserver-utils, gawk") #miss vulkan-tools
-    endif()
-endif()
-
-#debian 10
-if(${distro}${disversion} MATCHES "DebianGNULinux10")

=== po/CMakeLists.txt ===
include(Translations)
add_translations_directory("hardinfo2")
add_translations_catalog("hardinfo2" ../shell/ ../modules/ ../hardinfo2/ ../includes/ )

=== deps/qgears2/CMakeLists.txt ===
message(STATUS "qgears2 module being added...")

find_package(Qt5 REQUIRED Core Gui Widgets OpenGL)
include(FindPkgConfig)

if(HARDINFO2_QT5_MOCQT5)
  set(MOC "moc-qt5")
else()
  set(MOC "moc")
endif()

execute_process(COMMAND ${MOC} -DQT_NO_DEBUG -DQT_OPENGL_LIB -DQT_WIDGETS_LIB -DQT_GUI_LIB -DQT_CORE_LIB ${CMAKE_CURRENT_SOURCE_DIR}/qgears.h -o ${CMAKE_CURRENT_BINARY_DIR}/moc_qgears.cpp)
execute_process(COMMAND ${MOC} -DQT_NO_DEBUG -DQT_OPENGL_LIB -DQT_WIDGETS_LIB -DQT_GUI_LIB -DQT_CORE_LIB ${CMAKE_CURRENT_SOURCE_DIR}/qglgears.h -o ${CMAKE_CURRENT_BINARY_DIR}/moc_qglgears.cpp)
execute_process(COMMAND /usr/bin/${MOC} -DQT_NO_DEBUG -DQT_OPENGL_LIB -DQT_WIDGETS_LIB -DQT_GUI_LIB -DQT_CORE_LIB ${CMAKE_CURRENT_SOURCE_DIR}/qgears.h -o ${CMAKE_CURRENT_BINARY_DIR}/moc_qgears.cpp)
execute_process(COMMAND /usr/bin/${MOC} -DQT_NO_DEBUG -DQT_OPENGL_LIB -DQT_WIDGETS_LIB -DQT_GUI_LIB -DQT_CORE_LIB ${CMAKE_CURRENT_SOURCE_DIR}/qglgears.h -o ${CMAKE_CURRENT_BINARY_DIR}/moc_qglgears.cpp)
execute_process(COMMAND /usr/lib/qt5/bin/${MOC} -DQT_NO_DEBUG -DQT_OPENGL_LIB -DQT_WIDGETS_LIB -DQT_GUI_LIB -DQT_CORE_LIB ${CMAKE_CURRENT_SOURCE_DIR}/qgears.h -o ${CMAKE_CURRENT_BINARY_DIR}/moc_qgears.cpp)
execute_process(COMMAND /usr/lib/qt5/bin/${MOC} -DQT_NO_DEBUG -DQT_OPENGL_LIB -DQT_WIDGETS_LIB -DQT_GUI_LIB -DQT_CORE_LIB ${CMAKE_CURRENT_SOURCE_DIR}/qglgears.h -o ${CMAKE_CURRENT_BINARY_DIR}/moc_qglgears.cpp)
execute_process(COMMAND /usr/lib64/qt5/bin/${MOC} -DQT_NO_DEBUG -DQT_OPENGL_LIB -DQT_WIDGETS_LIB -DQT_GUI_LIB -DQT_CORE_LIB ${CMAKE_CURRENT_SOURCE_DIR}/qgears.h -o ${CMAKE_CURRENT_BINARY_DIR}/moc_qgears.cpp)
execute_process(COMMAND /usr/lib64/qt5/bin/${MOC} -DQT_NO_DEBUG -DQT_OPENGL_LIB -DQT_WIDGETS_LIB -DQT_GUI_LIB -DQT_CORE_LIB ${CMAKE_CURRENT_SOURCE_DIR}/qglgears.h -o ${CMAKE_CURRENT_BINARY_DIR}/moc_qglgears.cpp)
execute_process(COMMAND /usr/lib/i386-linux-gnu/qt5/bin/${MOC} -DQT_NO_DEBUG -DQT_OPENGL_LIB -DQT_WIDGETS_LIB -DQT_GUI_LIB -DQT_CORE_LIB ${CMAKE_CURRENT_SOURCE_DIR}/qgears.h -o ${CMAKE_CURRENT_BINARY_DIR}/moc_qgears.cpp)
execute_process(COMMAND /usr/lib/i386-linux-gnu/qt5/bin/${MOC} -DQT_NO_DEBUG -DQT_OPENGL_LIB -DQT_WIDGETS_LIB -DQT_GUI_LIB -DQT_CORE_LIB ${CMAKE_CURRENT_SOURCE_DIR}/qglgears.h -o ${CMAKE_CURRENT_BINARY_DIR}/moc_qglgears.cpp)

include_directories(
  .
  Qt5::OpenGL
  Qt5::Widgets
  Qt5::Gui
  Qt5::Core
)

add_executable(qgears2
  main.cpp
  qgears.cpp
  commonrenderer.cpp
  qglgears.cpp
  fdclock.cpp
  ${CMAKE_CURRENT_BINARY_DIR}/moc_qgears.cpp
  ${CMAKE_CURRENT_BINARY_DIR}/moc_qglgears.cpp
)

set_target_properties(qgears2 PROPERTIES COMPILE_FLAGS "-pipe -O2 -Wall -Wextra -D_REENTRANT -fPIC")

target_link_libraries(qgears2
  GL
  pthread
  Qt5::OpenGL
  Qt5::Widgets
  Qt5::Gui
  Qt5::Core
)

install(FILES ${CMAKE_BINARY_DIR}/deps/qgears2/qgears2 DESTINATION ${CMAKE_INSTALL_LIBDIR}/hardinfo2/modules
	PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
)
      
message(STATUS "qgears2 module added - DONE")

=== deps/vkgears/CMakeLists.txt ===
# Hardinfo2 - System Information & Benchmark
# Copyright hardinfo2 project, hwspeedy 2025
# License: GPL2+

message(STATUS "vkgears module being added...")
set (VULKAN_SDK "/opt/vulkan/1.2.182.0/x86_64")

include(CheckLibraryExists)
check_library_exists(m sqrtf "" HAVE_LIB_M)
if (HAVE_LIB_M)
    set(EXTRA_LIBS ${EXTRA_LIBS} m)
endif (HAVE_LIB_M)

set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")

find_package(PkgConfig)
pkg_check_modules(VULKAN vulkan)
find_package(Threads REQUIRED)


if(${HARDINFO2_VK_WAYLAND})
  message("-- VK_WAYLAND")
  find_path(WAYLAND_CLIENT_INCLUDE_DIR NAMES wayland-client.h )
  find_path(WAYLAND_INCLUDE PATH_SUFFIXES wayland NAMES wayland-client.h )
  find_path(LIBDECOR_INCLUDE PATH_SUFFIXES libdecor-0 NAMES libdecor.h )
  find_library(WAYLAND_CLIENT_LIBRARY NAMES wayland-client libwayland-client)
  find_library(LIBDECOR_LIBRARY NAMES libdecor-0.so)
#  find_library(XKBCOMMON_LIBRARY NAMES xkbcommon)
  set(WAYLAND_SOURCE wsi/wayland.c)
endif()
if(${HARDINFO2_VK_X11})
  message("-- VK_X11")
#  find_library(XKBCOMMON_LIBRARY NAMES xkbcommon)
#  find_library(XKBCOMMONX11_LIBRARY NAMES xkbcommon-x11)
  find_library(XCB_LIBRARY NAMES xcb)
  set(X11_SOURCE wsi/xcb.c)
endif()

# Find Vulkan library
include(FindVulkan)
if (NOT Vulkan_GLSLANG_VALIDATOR_EXECUTABLE)
    find_program (GLSL_LANG_VALIDATOR NAMES glslangValidator PATHS ${VULKAN_SDK}/bin)
    set(Vulkan_GLSLANG_VALIDATOR_EXECUTABLE "${GLSL_LANG_VALIDATOR}")
endif()


file(GLOB_RECURSE VERTEX_SHADER_SOURCE "gear.vert")
file(GLOB_RECURSE FRAGMENT_SHADER_SOURCE "gear.frag")
set(SHADER_SOURCE ${VERTEX_SHADER_SOURCE} ${FRAGMENT_SHADER_SOURCE})
source_group("shaders" FILES ${SHADER_SOURCE})

foreach(shader ${SHADER_SOURCE})
  add_custom_command(OUTPUT ${shader}.spv.h DEPENDS ${shader}
    COMMAND ${Vulkan_GLSLANG_VALIDATOR_EXECUTABLE} -V ${shader} -x -o ${shader}.spv.h)
  list(APPEND SHADERS ${shader}.spv.h)
endforeach(shader)

include_directories(${CMAKE_BINARY_DIR} ${WAYLAND_INCLUDE} ${Vulkan_INCLUDE_DIRS} ${LIBDECOR_INCLUDE})

#message(STATUS "Vulkanlib======${Vulkan_LIBRARIES}")

#devenv.set('VK_LOADER_LAYERS_ENABLE', 'VK_LAYER_KHRONOS_validation')
#devenv.set('VK_LAYER_SETTINGS_PATH', meson.current_source_dir())
set(VK_LOADER_LAYERS_ENABLE "VK_LAYER_KHRONOS_validation")
set(VK_LAYER_SETTINGS_PATH "${CMAKE_SOURCE_DIR}")

add_executable(vkgears vkgears.c matrix.c wsi/wsi.c ${WAYLAND_SOURCE} ${X11_SOURCE} ${SHADERS})
target_link_libraries(vkgears ${Vulkan_LIBRARIES} ${EXTRA_LIBS} ${LIBDECOR_LIBRARY} ${WAYLAND_CLIENT_LIBRARY} ${XCB_LIBRARY})
#${XKBCOMMON_LIBRARY} ${XKBCOMMONX11_LIBRARY}

install(FILES ${CMAKE_BINARY_DIR}/deps/vkgears/vkgears DESTINATION ${CMAKE_INSTALL_LIBDIR}/hardinfo2/modules
           PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
       )

message(STATUS "vkgears module added - DONE")

=== debian/changelog ===
hardinfo (2.2.13-1~mx25+2) mx; urgency=medium

  * Really fix iperf3 dependency.

 -- Steven Pusser <stevep@mxlinux.org>  Wed, 01 Oct 2025 16:28:57 -0700

hardinfo (2.2.13-1~mx23+1) mx; urgency=medium

  * Rebuild for MX Linux.
  * Make recommended packages explicit dependencies except fwupd, and make
    iperf3 suggested.
  * Add system_group.patch.

 -- Steven Pusser <stevep@mxlinux.org>  Tue, 30 Sep 2025 06:43:33 -0700

hardinfo (2.2.13-1~bpo13+1) trixie-backports; urgency=medium

  * Rebuild for trixie-backports.

 -- Boyuan Yang <byang@debian.org>  Sun, 21 Sep 2025 11:06:11 -0400

hardinfo (2.2.13-1) unstable; urgency=medium

  * New upstream release.
  * debian/copyright: Update information.
  * debian/control: Add new build-dep: glslang-tools, libdecor-0-dev,
    libvulkan-dev.

 -- Boyuan Yang <byang@debian.org>  Sun, 17 Aug 2025 17:55:37 -0400

=== debian/rules ===
--- 
+++ 
@@ -5,3 +5,8 @@
 
 %:
 	dh $@ --buildsystem=cmake
+
+# No dbgsym packages:
+override_dh_strip:
+	@echo "NO--THANKS ANYWAY--but not building dbgsym packages for MX Linux"
+	dh_strip --no-automatic-dbgsym
